[indent=4] 

//outputting random generated text from input and outputting result 

uses 
    GLib 

//-- declare global variables -- 
entry : Gtk.Entry 
label : Gtk.Label

 
//-- define the methods -- 

def getRandomNumber(RangeFrom:int, RangeTo:int) : int  /* function to create random number between range */ 
    return GLib.Random.int_range(RangeFrom,RangeTo) 

def getRandomChar() : char                             /* function to generate ascii codes from a-z and space (32) */ 
    num:int = getRandomNumber(0,27) 
    if num == 0 
        num = 32 
    else 
        num = num + 96 
    return (char) num 

def addRandomChar(myText:string) : string              /* function add text from command line */ 
    var retText = new StringBuilder 
    retText.append(myText) 
    retText.append_c(getRandomChar()) 
    return retText.str 

def IsEmpty(theText:string) : bool 
    if theText == null 
        return true 
    if theText == "" 
        return true 
    return false 

def on_button_clicked () 
    theText:string = entry.get_text() 
    
    if IsEmpty(theText) 
        entry.set_text("Please enter some text") 
        return 
    label.set_text("running") 
    Gdk.flush()


    theText = theText.down() 
    myText:string = "" 

    //timer : Timer = new Timer() 
    //timer.start() 


    do 
        do 
            myText = addRandomChar(myText) 
        while theText.len() != myText.len() 
        label.set_text(myText) 
        //Gdk.flush()
        print("%s", myText)
        if theText != myText 
            myText = "" 
    while theText != myText 
    label.set_text(myText) 

//-- main program -- 

init 
    Gtk.init (ref args) 

    //-- build the window -- 

    var window = new Gtk.Window (Gtk.WindowType.TOPLEVEL) 
    window.set_default_size (400, 50) 
    window.destroy += Gtk.main_quit 
    window.move(100 , 100)
  
    var vbox = new Gtk.VBox(false , 1) 
    vbox.border_width = 10 
    vbox.spacing = 10 
    window.add (vbox) 
  
    //-- the entry is global, so that it can be modified later -- 

    entry = new Gtk.Entry () 
    entry.set_editable(true) 
    entry.set_text("test") 
    vbox.pack_start (entry, false, true, 0); 

    var button = new Gtk.Button.with_label("enter some SHORT text (less 10 chars), then click here!") 
    vbox.pack_start (button, false, true, 0); 

    //-- define actions -- 

    button.clicked += on_button_clicked; 

    //  window 2
    var window2 = new Gtk.Window (Gtk.WindowType.TOPLEVEL) 
    window2.set_default_size (400, 50) 
    window2.destroy += Gtk.main_quit 
    window2.move(100 , 250)
    
    var vbox2 = new Gtk.VBox(false , 1) 
    vbox2.border_width = 10 
    vbox2.spacing = 10 
    window2.add (vbox2)
     
    label = new Gtk.Label ("")  
    label.set_text("") 
    vbox2.pack_start (label, false, true, 0); 

    
    //-- show the window, hand over to the Gtk mainloop -- 

    window2.show_all ()  
    window.show_all () 

        
    Gtk.main ()
